<?php
namespace Myquest\Controller;

use Doctrine\DBAL\Connection;
use Zeedhi\Framework\DataSource\DataSet;

class SACController
{

    const ANOM_EMAIL_ADDRESS = 'anonimo@anonimo.com';
    
    protected $entityManager;

    public function __construct($novoCodigo, $entityManager)
    {
        $this->novoCodigo = $novoCodigo;
        $this->entityManager = $entityManager;
    }

    public function insertFaleConoscoMessage($request, $response){
        
        $sql = "INSERT INTO FALECONOSCOAPP ( NRFALECONOSCOAPP, CDFILIAL, NRLOCALPESQ, NRORG, IDAPLICATIVO, IDSITUACAO, DSEMAILRESPOSTA, DSFALECONOSCOAPP, IDFALECONOSCOAPP, DSRESPOSTAAPP, DSEMAILCLIENTE, DSNOMECLIENTE, DTINCLUSAO, DTULTATU, IDATIVO) VALUES ( :NRFALECONOSCOAPP, :CDFILIAL, :NRLOCALPESQ, :NRORG, :IDAPLICATIVO, :IDSITUACAO, :DSEMAILRESPOSTA, :DSFALECONOSCOAPP, :IDFALECONOSCOAPP, :DSRESPOSTAAPP, :DSEMAILCLIENTE, :DSNOMECLIENTE, SYSDATE, SYSDATE, :IDATIVO)";
        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();
        
        $NRFALECONOSCOAPP = $this->novoCodigo->getCodeByTableName('FALECONOSCOAPP', $row['NRORG'], 1, 10, false);
        $params = [
            'NRFALECONOSCOAPP' => $NRFALECONOSCOAPP,
            'CDFILIAL' => $row['CDFILIAL'],
            'NRLOCALPESQ' => $row['NRLOCALPESQ'],
            'NRORG' => $row['NRORG'],
            "IDAPLICATIVO" => "MYQUEST",
            "IDSITUACAO" => "PENDENTE",
            'IDFALECONOSCOAPP' => $row['IDFALECONOSCOAPP'],
            "DSEMAILRESPOSTA" => "",
            "DSNOMECLIENTE" => $row['DSNOMECLIENTE'],
            "DSEMAILCLIENTE" => $row['DSEMAILCLIENTE'],
            'DSFALECONOSCOAPP' => $row['DSFALECONOSCOAPP'],
            'IDATIVO' => $row['IDATIVO'],
            // 'DTINCLUSAO' => $row['currentDate'],
            // 'DTULTATU' => $row['currentDate'],
            "DSRESPOSTAAPP" => null
        ];

        $statement = $conn->prepare($sql);
        $statement->execute($params);
    }
    
    public function getFaleConoscoMessages($request, $response){
        $sql = "SELECT NVL(DSNOMECLIENTE, DSEMAILCLIENTE) AS DSEMAILCLIENTE, TO_CHAR(DTULTATU, 'DD/MM/YYYY') DTULTATU, TO_CHAR(DTINCLUSAO, 'DD/MM/YYYY') DTINCLUSAO, NRFALECONOSCOAPP, DSFALECONOSCOAPP, IDFALECONOSCOAPP, DSRESPOSTAAPP FROM FALECONOSCOAPP F WHERE CDFILIAL = :CDFILIAL AND NRLOCALPESQ = :NRLOCALPESQ AND DTINCLUSAO IS NOT NULL AND F.IDATIVO = 'S' ORDER BY F.DTINCLUSAO DESC";
        
        $conn = $this
            ->entityManager
            ->getConnection();
        $row = $request->getRow();
        $params = [
            'CDFILIAL' => $row['CDFILIAL'], 
            'NRLOCALPESQ' => $row['NRLOCALPESQ'], 
        ];

        $statement = $conn->prepare($sql);
        $statement->execute($params);

        $result = $statement->fetchAll();
        $response->addDataSet(new DataSet('mensagemSAC', $result));
    }

    protected function executeInsertSql($sql, $params = null)
    {
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare($sql);
        $statement->execute($params);
    }

}

