<?php

namespace Myquest\Service;

class LoginService
{

    protected $entityManager;

    public function __construct($novoCodigo, $entityManager, $fileServerFilesPath)
    {
        $this->entityManager = $entityManager;
        $this->fileServerFilesPath = $fileServerFilesPath;
        $this->novoCodigo = $novoCodigo;
    }

    public function executeInsertSql($sql, $params = null)
    {
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare($sql);
        $statement->execute($params);
    }

    public function executeSql($sql, $params = null)
    {
        $conn = $this->entityManager->getConnection();
        $statement = $conn->prepare($sql);
        $statement->execute($params);

        return $statement->fetchAll();
    }

    public function changeFGForByte64($URL)
    {
        $fullUrl = $this->fileServerFilesPath . $URL;
        $b64 = null;

        try {
            $fileContent = @file_get_contents($fullUrl);
            if ($fileContent !== false) {
                return 'data:image/jpg;base64,' . base64_encode($fileContent);
            }
            $b64 = base64_encode($fileContent);
        } catch (\Throwable $th) {
            //throw $th;
        }
        return $b64;
    }

    public function getInforData($NRORG, $CDFILIAL, $NRLOCALPESQ, $CDOPERADOR)
    {
        $sql = "SELECT
                    NRINFORMATIVO,
                    NRLOCALPESQ,
                    URLIMAGEM,
                    DSTITULO,
                    TXCONTEUDO
                FROM
                    INFORMATIVOMYMENU
                WHERE
                    CDFILIAL = :CDFILIAL
                    AND NRORG = :NRORG
                    AND ( IDEXIBICAO = 'A'
                        OR IDEXIBICAO = 'Q' )
                    AND ( DTEXPIRA IS NULL
                        OR TRUNC(DTEXPIRA) >= TRUNC(SYSDATE) )
                    AND URLIMAGEM IS NOT NULL
                    AND NRLOCALPESQ = :NRLOCALPESQ";
        $params = array(
            "NRORG" => $NRORG,
            "CDFILIAL" => $CDFILIAL,
            "NRLOCALPESQ" => $NRLOCALPESQ
        );
        $inform = $this->executeSql($sql, $params);

        for ($i = 0; $i < sizeof($inform); $i++) {
            $URLIMAGEM = $inform[$i]['URLIMAGEM'];
            $inform[$i]['URLIMAGEM'] = $this->changeFGForByte64($URLIMAGEM);
        }
        return $inform;
    }

    public function getCardData($NRORG, $CDFILIAL, $NRLOCALPESQ, $CDOPERADOR, $HIDE_CARD_EXIBITIION)
    {
        if(!$HIDE_CARD_EXIBITIION){
            $SERVICES_SQL = "SELECT NULL AS CDFILCENTPME, S.CDFILIAL, S.CDSERVFILI, NVL( S.NMFANTASSERV, S.NMSERVICO) AS NMSERVICO, S.NRORG, S.IDTIPOSERV, CASE WHEN S.HRINICSERV IS NULL THEN S.HRINICSERV ELSE SUBSTR( S.HRINICSERV, 0, 2 ) || ':' || SUBSTR( S.HRINICSERV, 3, 2 ) END AS HRINICIO, CASE WHEN S.HRFINASERV IS NULL THEN S.HRFINASERV ELSE SUBSTR( S.HRFINASERV, 0, 2 ) || ':' || SUBSTR( S.HRFINASERV, 3, 2 ) END AS HRFINAL, NULL AS CDTIPOCARD, NULL AS NMTIPOCARD, NULL AS CDDIETPAD, NULL AS DSDIETPAD, S.FGFOTOSERVICO AS IMGSERVICO, NVL(S.NRDIASANT, 0) AS NRDIASANT, NVL(S.NRDIASPOS, 0) AS NRDIASPOS, NVL(S.NRLIMSEGPEDIDO, 0) AS NRLIMSEGPEDIDO, CASE WHEN S.HRLIMSEGPEDIDO IS NULL THEN '00:00' ELSE (SUBSTR( S.HRLIMSEGPEDIDO, 0, 2 ) || ':' || SUBSTR( S.HRLIMSEGPEDIDO, 3, 2 )) END AS HRLIMSEGPEDIDO, S.IDRESERVASERVMYMENU FROM SERVICO S WHERE S.IDDISPONIVELMYMENU = 'S' AND S.CDFILIAL = :CDFILIAL AND S.NRORG =:NRORG ORDER BY NMSERVICO";
            $params = array(
                "NRORG" => $NRORG,
                "CDFILIAL" => $CDFILIAL,
            );
            
            $services = $this->executeSql($SERVICES_SQL, $params);
            $services = $this->setPlateData($services);
            
            return $services;
        } else {
            return [];
        }
    }

    public function setPlateData($services)
    {
        $SQL = "SELECT TO_CHAR(C.DTCARDAPIO,'DD/MM/YYYY') AS DTCARDAPIO, P.DSPRATO, P.IDGLUTEN, P.IDLACTOSE, P.CDPRATO, P.NMGRUPOPRATOPESQ, P.NMPRATO, P.NMTIPOPRAT, P.VRAVALIACAO, P.QTAVALIACAO, P.URL_FOTOPRATO, P.NRCARDPME, P.NRCARDAPIO, P.CDTIPOPRAT, P.CDFILAUXPRAT, P.NRSEQPRATCAR, P.CDMEDICASE, P.NMMEDICASE, P.QTMEDICASE, TO_CHAR(P.CALORIAS_KCAL,'999990.99') AS CALORIAS_KCAL_ROUND, CASE WHEN BLOB_FOTOPRATO IS NOT NULL THEN base64encode(BLOB_FOTOPRATO) ELSE NULL END FOTO_CONVERIDA, P.IDRESERVAMYMENU, P.IDCONCNFMES, CASE WHEN INSTR(P.NMTIPOPRAT,'(Opção)') > 0 THEN 'S' ELSE 'N' END AS IDOPCCNFMES FROM CARDADIA C, SERVICO S, TABLE (PRATOS_MYMENU(NULL, NULL, :CDFILIAL, :CDSERVFILI, 'N', NULL, C.DTCARDAPIO, :NRORG)) P WHERE (S.CDFILIAL = :CDFILIAL) AND (S.CDSERVFILI = :CDSERVFILI) AND (C.CDFILIAL = S.CDFILIAL) AND (C.CDSERVFILI = S.CDSERVFILI) AND (C.NRCARDAPIO = P.NRCARDAPIO) AND (C.CDDIETPAD IS NULL) AND (C.DTCARDAPIO BETWEEN TRUNC(SYSDATE) - NVL(S.NRDIASANT,0) AND TRUNC(SYSDATE) + NVL(S.NRDIASPOS,0)) ORDER BY C.DTCARDAPIO, TO_NUMBER(P.NRORDPRATCAR)";
        for ($i = 0; $i < sizeof($services); $i++) {

            // $services[$i]['IMGSERVICO'] = isset($services[$i]['IMGSERVICO']) ? $this->changeFGForByte64($services[$i]['IMGSERVICO']) : null;

                // "NRUSUARIOAPP" => null,
                // "CDDIETPAD" => $services[$i]['CDDIETPAD'],
                // "CDTIPOCARD" => $services[$i]['CDTIPOCARD'],
                // "IDTIPOSERV" => $services[$i]['IDTIPOSERV'],
                // "CDFILCENTPME" => $services[$i]['CDFILCENTPME'],
            $params = array(
                "NRORG" => $services[$i]['NRORG'],
                "CDSERVFILI" => $services[$i]['CDSERVFILI'],
                "CDFILIAL" => $services[$i]['CDFILIAL']
            );

            $plates = $this->executeSql($SQL, $params);

            for ($j = 0; $j < sizeof($plates); $j++) {
                $plates[$j]['CDFILIAL'] = $services[$i]['CDFILIAL'];
                $plates[$j]['CDFILCENTPME'] = $services[$i]['CDFILCENTPME'];
                $plates[$j]['CDDIETPAD'] = $services[$i]['CDDIETPAD'];
                $plates[$j]['NRORG'] = $services[$i]['NRORG'];
                $plates[$j]['CDTIPOCARD'] = $services[$i]['CDTIPOCARD'];
                $plates[$j]['CDSERVFILI'] = $services[$i]['CDSERVFILI'];
                $plates[$j]['FOTO_CONVERIDA'] = 'data:image/jpg;base64,' . $plates[$j]['FOTO_CONVERIDA'];
                $plates[$j]['nutrientes'] = $this->setNutrientData($plates[$j], $services[$i]);
            }
            $services[$i]['plates'] = $plates;
        }
        return $services;
    }

    public function setNutrientData($plate, $curService)
    {
        $SQL = "SELECT G.CDGRUPNUTR, G.NMGRUPNUTR, N.CDNUTRIENTE, N.NMNUTRIENTE, N.NMREDUZIDO, TO_CHAR(NUT.QTNUTRIENTE, '9999990.9999') AS QTNUTRIENTE , N.SGUNIDADE FROM ( SELECT CDNUTRCALC, SUM(P.QTNUTRCALC) AS QTNUTRIENTE FROM TABLE ( NUTRIENTE_PRATO_PME(:CDFILCENTPME,:CDTIPOCARD,:CDFILIAL,:CDSERVFILI,NULL,'S',:CDPRATO,:CDPRATO) ) P WHERE :IDTIPOSERV = 'M' GROUP BY CDNUTRCALC UNION ALL SELECT CDNUTRCALC, SUM(P.QTNUTRCALC) AS QTNUTRIENTE FROM TABLE ( NUTRIENTE_PRATO(:CDFILIAL,:CDSERVFILI,NULL,'S',:CDPRATO,:CDPRATO) ) P WHERE :IDTIPOSERV <> 'M' GROUP BY CDNUTRCALC ) NUT INNER JOIN NUTRIENTE N ON NUT.CDNUTRCALC = N.CDNUTRIENTE AND NRORG = :NRORG INNER JOIN GRUPNUTR G ON G.CDGRUPNUTR = N.CDGRUPNUTR ORDER BY G.CDGRUPNUTR, N.CDNUTRIENTE";
        $params = array(
            "CDPRATO" => $plate['CDPRATO'],
            "NRORG" => $curService['NRORG'],
            "CDSERVFILI" => $curService['CDSERVFILI'],
            "CDTIPOCARD" => $curService['CDTIPOCARD'],
            "IDTIPOSERV" => $curService['IDTIPOSERV'],
            "CDFILCENTPME" => $curService['CDFILCENTPME'],
            "CDFILIAL" => $curService['CDFILIAL'],
        );

        $nutrientes = $this->executeSql($SQL, $params);

        return $nutrientes;
    }

    public function getPesqData($NRORG, $CDFILIAL, $NRLOCALPESQ, $CDOPERADOR, $isPresentationMode)
    {
        if (!$isPresentationMode) {
            $params = array(
                'NRORG' => $NRORG,
                'CDFILIAL' => $CDFILIAL,
                'NRLOCALPESQ' => $NRLOCALPESQ,
            );

            $PROGRAMPESQ = "SELECT DISTINCT P.NRQUESTIONARIO, P.NRPROGRAMACAOPESQ, TO_CHAR(P.DTINICIO, 'DD/MM/YYYY') AS DTINICIO, TO_CHAR(P.DTFIM, 'DD/MM/YYYY') AS DTFIM, P.HRINICIO, P.HRFIM FROM PROGRAMACAOPESQ P, DATA DT WHERE ( P.IDAPLICATIVO = 'MYQUEST' ) AND ( DT.DTDATA BETWEEN TRUNC(P.DTINICIO) AND TRUNC(P.DTFIM) ) AND ( P.NRORG =:NRORG ) AND ( P.CDFILIAL =:CDFILIAL ) AND ( DT.DTDATA BETWEEN SYSDATE AND SYSDATE + 7 ) AND ( NVL(P.NRLOCALPESQ,:NRLOCALPESQ) =:NRLOCALPESQ OR :NRLOCALPESQ IS NULL ) ORDER BY P.HRINICIO";
            $PROGRAMPESQ = $this->executeSql($PROGRAMPESQ, $params);

            $QUESTAO = "SELECT * FROM QUESTAO";
            $QUESTAO = $this->executeSql($QUESTAO);

            $RESPOSTA = "SELECT * FROM RESPOSTA";
            $RESPOSTA = $this->executeSql($RESPOSTA);

            $QUESTIONARIO = "SELECT * FROM QUESTIONARIO";
            $QUESTIONARIO = $this->executeSql($QUESTIONARIO);

            $ITEMQUESTIONARIO = "SELECT ITEMQUESTIONARIO.* FROM ITEMQUESTIONARIO INNER JOIN QUESTAO ON ITEMQUESTIONARIO.NRQUESTAO = QUESTAO.NRQUESTAO";
            $ITEMQUESTIONARIO = $this->executeSql($ITEMQUESTIONARIO);

            return array(
                'PROGRAMPESQ' => $PROGRAMPESQ,
                'QUESTAO' => $QUESTAO,
                'RESPOSTA' => $RESPOSTA,
                'QUESTIONARIO' => $QUESTIONARIO,
                'ITEMQUESTIONARIO' => $ITEMQUESTIONARIO,
            );
        } else {
            return array(
                'PROGRAMPESQ' => [],
                'QUESTAO' => [],
                'RESPOSTA' => [],
                'QUESTIONARIO' => [],
                'ITEMQUESTIONARIO' => [],
            );
        }
    }

    public function getTurnoData($NRLOCALPESQ, $NRORG)
    {
        $sql = "SELECT * FROM TURNOLOCALPESQ WHERE NRLOCALPESQ = :NRLOCALPESQ AND NRORG = :NRORG ORDER BY HRINITURNOLOCALPESQ";

        $params = array(
            "NRORG" => $NRORG,
            "NRLOCALPESQ" => $NRLOCALPESQ,
        );

        $data = $this->executeSql($sql, $params);
        return $data;
    }

    public function insertAVA($avals, $NRLOCALPESQ)
    {
        $params = array();
        $sql = "INSERT INTO AVALIACAOPRATO (NRAVALIACAOPRATO, CDFILCENTPME, CDTIPOCARD, NRCARDPME, CDFILIAL, CDSERVFILI, NRCARDAPIO, CDDIETPAD, NRSEQPRATCAR, CDFILAUXPRAT, CDPRATO, CDTIPOPRAT, VRAVALIACAOPRATO, DSAVALIACAOPRATO, NRUSUARIOAPP, NRORG, DTCARDAPIO, NRLOCALPESQ)
                VALUES (:NRAVALIACAOPRATO, :CDFILCENTPME, :CDTIPOCARD, :NRCARDPME, :CDFILIAL, :CDSERVFILI, :NRCARDAPIO, :CDDIETPAD, :NRSEQPRATCAR, :CDFILAUXPRAT, :CDPRATO, :CDTIPOPRAT, :VRAVALIACAOPRATO, null, null, :NRORG, :DTCARDAPIO, :NRLOCALPESQ)";

        foreach ($avals as $key => $aval) {

            $NEWCODE = $this->novoCodigo->getCodeByTableName('AVALIACAOPRATO', $aval['NRORG'], 1, 10, false);
            $params = array(
                'NRAVALIACAOPRATO' => $NEWCODE,
                'CDFILCENTPME' => $aval['CDFILCENTPME'],
                'CDTIPOCARD' => $aval['CDTIPOCARD'],
                'NRCARDPME' => $aval['NRCARDPME'],
                'CDFILIAL' => $aval['CDFILIAL'],
                'CDSERVFILI' => $aval['CDSERVFILI'],
                'NRCARDAPIO' => $aval['NRCARDAPIO'],
                'CDDIETPAD' => $aval['CDDIETPAD'],
                'NRSEQPRATCAR' => $aval['NRSEQPRATCAR'],
                'CDFILAUXPRAT' => $aval['CDFILAUXPRAT'],
                'CDPRATO' => $aval['CDPRATO'],
                'CDTIPOPRAT' => $aval['CDTIPOPRAT'],
                'DTCARDAPIO' => $aval['DTCARDAPIO'],
                'VRAVALIACAOPRATO' => $aval['curAval'],
                'NRLOCALPESQ' => $NRLOCALPESQ,
                'NRORG' => $aval['NRORG'],
            );
            $this->executeInsertSql($sql, $params);
        }
    }

    public function insertASW($resps)
    {
        $sqlEXECUCAOPESQ = "INSERT INTO EXECUCAOPESQ (NREXECUCAOPESQ, CDFILIAL, NRLOCALPESQ, NRQUESTIONARIO, IDAPLICATIVO, NRUSUARIOPESQ, DTHRINICIOPESQ, DTHRFIMPESQ, NRORG, NRPROGRAMACAOPESQ) VALUES ( :NREXECUCAOPESQ, :CDFILIAL, :NRLOCALPESQ, :NRQUESTIONARIO, :IDAPLICATIVO, :NRUSUARIOPESQ, :DTHRINICIOPESQ, :DTHRFIMPESQ, :NRORG, :NRPROGRAMACAOPESQ )";
        $sqlRESPOSTAPESQ = "INSERT INTO RESPOSTAPESQ (NRRESPOSTAPESQ, NREXECUCAOPESQ, NRQUESTAO, TXRESPOSTAPESQ, NRRESPOSTA, NRORG, NRRESPOSTAANTERIOR) VALUES(:NRRESPOSTAPESQ,:NREXECUCAOPESQ,:NRQUESTAO,:TXRESPOSTAPESQ,:NRRESPOSTA,:NRORG,:NRRESPOSTAANTERIOR)";
        foreach ($resps as $key => $execPesq) {

            $NREXECUCAOPESQ = $this->novoCodigo->getCodeByTableName('EXECUCAOPESQ', $execPesq['NRORG'], 1, 10, false);
            $params = array(
                'NREXECUCAOPESQ' => $NREXECUCAOPESQ,
                'CDFILIAL' => $execPesq['CDFILIAL'],
                'NRLOCALPESQ' => isset($execPesq['NRLOCALPESQ']) ? $execPesq['NRLOCALPESQ'] : null,
                'NRQUESTIONARIO' => $execPesq['NRQUESTIONARIO'],
                'IDAPLICATIVO' => $execPesq['IDAPLICATIVO'],
                'NRUSUARIOPESQ' => $execPesq['NRUSUARIOPESQ'],
                'DTHRINICIOPESQ' => $execPesq['DTHRINICIOPESQ'],
                'DTHRFIMPESQ' => $execPesq['DTHRFIMPESQ'],
                'NRORG' => $execPesq['NRORG'],
                'NRPROGRAMACAOPESQ' => $execPesq['NRPROGRAMACAOPESQ'],
            );
            $this->executeInsertSql($sqlEXECUCAOPESQ, $params);

            foreach ($execPesq['REPOSTASPESQ'] as $key => $respPesq) {

                if (isset($respPesq['NRQUESTAO'])) {
                    $NRRESPOSTAPESQ = $this->novoCodigo->getCodeByTableName('RESPOSTAPESQ', $execPesq['NRORG'], 1, 10, false);
                    $params2 = array(
                        'NREXECUCAOPESQ' => $NREXECUCAOPESQ,
                        'NRRESPOSTAPESQ' => $NRRESPOSTAPESQ,
                        'NRQUESTAO' => $respPesq['NRQUESTAO'],
                        'TXRESPOSTAPESQ' => $respPesq['TXRESPOSTAPESQ'],
                        'NRRESPOSTA' => $respPesq['NRRESPOSTA'],
                        'NRORG' => $execPesq['NRORG'],
                        'NRRESPOSTAANTERIOR' => $respPesq['NRRESPOSTAANTERIOR'],
                    );
                    $this->executeInsertSql($sqlRESPOSTAPESQ, $params2);
                } else {
                    foreach ($respPesq as $key => $respPesqMult) {
                        $NRRESPOSTAPESQ = $this->novoCodigo->getCodeByTableName('RESPOSTAPESQ', $execPesq['NRORG'], 1, 10, false);
                        $params2 = array(
                            'NREXECUCAOPESQ' => $NREXECUCAOPESQ,
                            'NRRESPOSTAPESQ' => $NRRESPOSTAPESQ,
                            'NRQUESTAO' => $respPesqMult['NRQUESTAO'],
                            'TXRESPOSTAPESQ' => $respPesqMult['TXRESPOSTAPESQ'],
                            'NRRESPOSTA' => $respPesqMult['NRRESPOSTA'],
                            'NRORG' => $execPesq['NRORG'],
                            'NRRESPOSTAANTERIOR' => $respPesqMult['NRRESPOSTAANTERIOR'],
                        );
                        $this->executeInsertSql($sqlRESPOSTAPESQ, $params2);
                    }
                }
            }
        }
    }

    public function insertReservedServices($service, $nrLocalPesq){
        
        $newCode = $this->novoCodigo->getCodeByTableName('AVALIACAOSERVICO', $service['NRORG'], 1, 10, false);
        $sql = "INSERT INTO AVALIACAOSERVICO (NRAVALIACAOSERVICO,CDFILIAL,CDSERVFILI,
            NRORG,CDDIETPAD,CDFILCENTPME,CDTIPOCARD,DSCONSUMO,HRCONSUMO,NMUSUARIO, IDCONSUMO, DTCARDAPIO, NRLOCALPESQ)
            VALUES (:NRAVALIACAOSERVICO,:CDFILIAL,:CDSERVFILI,:
            NRORG,:CDDIETPAD,:CDFILCENTPME,:CDTIPOCARD,:DSCONSUMO,:HRCONSUMO,:NMUSUARIO, :IDCONSUMO, :DTCARDAPIO, :NRLOCALPESQ)";

        $params = array(
            "NRAVALIACAOSERVICO"=>$newCode,
            "IDCONSUMO"=>"S",
            "CDFILIAL"=>$service["CDFILIAL"],
            "CDSERVFILI"=>$service["CDSERVFILI"],
            "NRORG"=>$service["NRORG"],
            "CDDIETPAD"=>$service["CDDIETPAD"],
            "CDFILCENTPME"=>$service["CDFILCENTPME"],
            "CDTIPOCARD"=>$service["CDTIPOCARD"],
            "DSCONSUMO"=>$service["DSCONSUMO"],
            "DTCARDAPIO"=>$service["DTCARDAPIO"],
            "HRCONSUMO"=>$service["HRCONSUMO"],
            "NMUSUARIO"=>$service["NMUSUARIO"],
            "NRLOCALPESQ"=>$nrLocalPesq
        );

        $this->executeInsertSql($sql, $params);
    }

    public function insertReservedPlates($plate, $nrLocalPesq){
        
        $newCode = $this->novoCodigo->getCodeByTableName('AVALIACAOPRATO', $plate['NRORG'], 1, 10, false);
        $sql = "INSERT INTO AVALIACAOPRATO (NRAVALIACAOPRATO,CDFILIAL,CDSERVFILI,
            NRORG,CDDIETPAD,CDFILCENTPME,CDTIPOCARD,DSCONSUMO,HRCONSUMO,NMUSUARIO, NRCARDAPIO, CDFILAUXPRAT, CDPRATO, IDCONSUMO, DTCARDAPIO, NRLOCALPESQ, NRSEQPRATCAR, CDTIPOPRAT)
            VALUES (:NRAVALIACAOPRATO,:CDFILIAL,:CDSERVFILI,:NRORG,:CDDIETPAD,:CDFILCENTPME,
            :CDTIPOCARD,:DSCONSUMO,:HRCONSUMO,:NMUSUARIO, :NRCARDAPIO, :CDFILAUXPRAT, :CDPRATO, :IDCONSUMO, :DTCARDAPIO, :NRLOCALPESQ, :NRSEQPRATCAR, :CDTIPOPRAT)";

        $params = array(
            "NRAVALIACAOPRATO"=>$newCode,
            "IDCONSUMO"=>"S",
            "CDFILIAL"=>$plate["CDFILIAL"],
            "CDSERVFILI"=>$plate["CDSERVFILI"],
            "NRORG"=>$plate["NRORG"],
            "CDDIETPAD"=>$plate["CDDIETPAD"],
            "CDFILCENTPME"=>$plate["CDFILCENTPME"],
            "CDFILAUXPRAT"=>$plate["CDFILAUXPRAT"],
            "CDPRATO"=>$plate["CDPRATO"],
            "NRCARDAPIO"=>$plate["NRCARDAPIO"],
            "CDTIPOCARD"=>$plate["CDTIPOCARD"],
            "DTCARDAPIO"=>$plate["DTCARDAPIO"],
            "DSCONSUMO"=>$plate["DSCONSUMO"],
            "HRCONSUMO"=>$plate["HRCONSUMO"],
            "NMUSUARIO"=>$plate["NMUSUARIO"],
            "NRSEQPRATCAR"=>$plate["NRSEQPRATCAR"],
            "NRLOCALPESQ"=>$nrLocalPesq,
            "CDTIPOPRAT"=>$plate["CDTIPOPRAT"],
        );

        $this->executeInsertSql($sql, $params);
    }
}
 
 